
#include "v3.h"

#include <iostream>

using namespace std;

V3::V3(float _x, float _y, float _z) : x(_x), y(_y), z(_z) {}

V3 V3::operator+(V3 op2) {

  V3 ret;
  ret.x = x+op2.x;
  ret.y = y+op2.y;
  ret.z = z+op2.z;
  return ret;

}

float V3::operator*(V3 op2) {

  return (x*op2.x+y*op2.y+z*op2.z);

}

ostream& operator<<(ostream &ostr, V3 v) {

  return ostr << v.x << " " << v.y << " " << v.z;

}

float& V3::operator[](int i) {

  switch (i) {
    case 0: return x;
    case 1: return y;
    case 2: return z;
    default:
      cerr << "INTERNAL ERROR: bad index" << endl;
      return x;
  }

}
