#include "scene.h"
#include "v3.h"
#include "M3x3.h"

#include <iostream>

using namespace std;

Scene *scene = 0;

Scene::Scene() {

  gui = new GUI;
  fb = new FrameBuffer(20, 40, 640, 480);
  fb->label("Frame buffer");
  gui->show();

}

void Scene::Show() {

  gui->uiw->position(20+fb->w+20, 40);
  unsigned int color = 0xFF000000;
  fb->Set(color);
  fb->show();

}

void Scene::Rotate() {

  {
    V3 v0(1.0f, 0.3f, 2.0f);
    V3 v1(1.0f, 0.3f, 2.0f);
    V3 v2(0.0f, 0.0f, 0.0f);
    v2 = v0+v1;
    cerr << v2 << endl;
    cerr << v2[0] << endl;
    v2[1] = 34.0f;
    cerr << v2[1] << endl;
    M3x3 m;
    m[0] = v0;
    m[1] = v1;
    m[2] = v2;

  }

  {
    unsigned int colors[2] = {0xFFAAAAAA, 0xFFFFFFFF};
    fb->SetGrid(40, colors);
    fb->redraw();
    return;
  }

  {
    int u, v = 50, sizePix = 15;
    unsigned int color = 0xFFFFFFFF;
    for (u = 0; u < fb->w; u++) {
      fb->Set(0xFF000000);
      fb->DrawDiagonalCross(u, v, color, sizePix);
      fb->redraw();
      Fl::check();
    }
  }

}

